commit a87bd5b303e01724fa4cec576a5d824186a8074c
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Thu Dec 25 09:16:09 2025 +0000

    daemon_modules_preload option

diff --git a/src/src/daemon.c b/src/src/daemon.c
index 056bf6311..e8432196c 100644
--- a/src/src/daemon.c
+++ b/src/src/daemon.c
@@ -1667,6 +1667,21 @@ return string_from_gstring(g);
 }
 
 
+
+static void
+daemon_preload_modules(void)
+{
+#ifdef LOOKUP_MODULE_DIR
+uschar namebuf[32];
+const uschar * list = daemon_modules_load, * ele;
+int sep = 0;
+
+while (ele = string_nextinlist(&list, &sep, namebuf, sizeof(namebuf)))
+  mod_load_anyclass(ele);
+#endif
+}
+
+
 /*************************************************
 *              Exim Daemon Mainline              *
 *************************************************/
@@ -1733,6 +1748,10 @@ debugging lines get the pid added. */
 
 DEBUG(D_any|D_v) debug_selector |= D_pid;
 
+/* Get any requested dynamic-load modules loaded */
+
+daemon_preload_modules();
+
 /* Allocate enough pollstructs for inetd mode plus the ancillary sockets;
 also used when there are no listen sockets. */
 
diff --git a/src/src/drtables.c b/src/src/drtables.c
index 21c9feb60..ec2c4c33a 100644
--- a/src/src/drtables.c
+++ b/src/src/drtables.c
@@ -209,6 +209,35 @@ if (!lookup_mod_load(name, errstr)) return FALSE;
 return TRUE;
 }
 
+
+/* Try to load a module of any class, given just the name.
+This is used for the daemon_modules_load option.
+Do not bother with class auth,router,transport - readconf will load if used.
+*/
+
+void
+mod_load_anyclass(const uschar * name)
+{
+DIR * dd;
+const pcre2_code * regex_class;
+
+/* Find the class for this name, by checking the lookup modules dir.
+We assume the .so files there are properly worded, and that the names
+are distinct. */
+
+if (!(dd = open_module_dir())) return;
+
+regex_class = regex_must_compile(
+  string_sprintf("^%s_(lookup|miscmod)\\." DYNLIB_FN_EXT "$", name),
+  MCS_NOFLAGS, TRUE);
+
+for (struct dirent * ent; ent = readdir(dd); )
+  if (regex_match_and_setup(regex_class, US ent->d_name, 0, 0))
+    if (Ustrcmp(expand_nstring[1], "miscmod") == 0)
+      (void) misc_mod_find(name, NULL);
+    else	/* assume "lookup" */
+      if (!tree_search(lookups_tree, name)) lookup_one_mod_load(name, NULL);
+}
 #endif	/*LOOKUP_MODULE_DIR*/
 
 const lookup_info *
@@ -303,7 +332,7 @@ const char * errormsg;
 EARLY_DEBUG(D_any, "Loading module %q\n", name);
 if (!(dl = mod_open(name, US"miscmod", errstr)))
   {
-  if (errstr) EARLY_DEBUG(D_any, " mod_open: %s\n", *errstr);
+  if (errstr && *errstr) EARLY_DEBUG(D_any, " mod_open: %s\n", *errstr);
   return NULL;
   }
 
diff --git a/src/src/exim.c b/src/src/exim.c
index 8c5089f7b..7e90e927c 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -1756,10 +1756,6 @@ len = Ustrlen(big_buffer);
 
 (void) macros_expand(0, &len, &macro_found);
 
-#ifdef LOOKUP_MODULE_DIR
-//mod_load_check(big_buffer);
-#endif
-
 if (isupper(big_buffer[0]) && !(macro_found & MACRO_FIRST))
   {
   if (macro_read_assignment(big_buffer))
diff --git a/src/src/functions.h b/src/src/functions.h
index 57ae06c58..fd6cab0d5 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -376,7 +376,7 @@ extern BOOL    moan_to_sender(int, const error_block *, const header_line *,
 extern void    moan_write_from(FILE *);
 extern void    moan_write_references(FILE *, uschar *);
 #ifdef LOOKUP_MODULE_DIR
-//extern void    mod_load_check(const uschar *);
+extern void    mod_load_anyclass(const uschar *);
 #endif
 extern void    mod_names(FILE *);
 extern FILE   *modefopen(const uschar *, const char *, mode_t);
diff --git a/src/src/globals.c b/src/src/globals.c
index 4fe89f727..2b2270899 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -639,6 +639,7 @@ cut_t   cutthrough = {	/* All remaining items 0/FALSE/NULL */
   .cctx =		{.sock = -1},			/* open connection */
 };
 
+uschar *daemon_modules_load    = NULL;
 int	daemon_notifier_fd     = -1;
 uschar *daemon_smtp_port       = US"smtp";
 int     daemon_startup_retries = 9;
diff --git a/src/src/globals.h b/src/src/globals.h
index f8cd0548b..befaf308b 100644
--- a/src/src/globals.h
+++ b/src/src/globals.h
@@ -461,6 +461,7 @@ typedef struct {
 } cut_t;
 extern cut_t cutthrough;               /* Deliver-concurrently */
 
+extern uschar *daemon_modules_load;    /* Dyn-load modules to preload */
 extern int     daemon_notifier_fd;     /* Unix socket for notifications */
 extern uschar *daemon_smtp_port;       /* Can be a list of ports */
 extern int     daemon_startup_retries; /* Number of times to retry */
diff --git a/src/src/macro_predef.c b/src/src/macro_predef.c
index 4778ace64..59894cbb3 100644
--- a/src/src/macro_predef.c
+++ b/src/src/macro_predef.c
@@ -385,6 +385,7 @@ avail_list(drtable, tag, US"static", FALSE);
 avail_list(drtable, tag, US"dynamic", TRUE);
 }
 
+/* Make lists of the drivers (by class, and static/dynamic) we are building */
 static void
 avail(void)
 {
diff --git a/src/src/readconf.c b/src/src/readconf.c
index 46adac621..356321765 100644
--- a/src/src/readconf.c
+++ b/src/src/readconf.c
@@ -98,6 +98,7 @@ static optionlist optionlist_config[] = {
   { "check_spool_space",        opt_Kint,        {&check_spool_space} },
   { "chunking_advertise_hosts", opt_stringptr,	 {&chunking_advertise_hosts} },
   { "commandline_checks_require_admin", opt_bool,{&commandline_checks_require_admin} },
+  { "daemon_modules_load",	opt_stringptr,   {&daemon_modules_load} },
   { "daemon_smtp_port",         opt_stringptr|opt_hidden, {&daemon_smtp_port} },
   { "daemon_smtp_ports",        opt_stringptr,   {&daemon_smtp_port} },
   { "daemon_startup_retries",   opt_int,         {&daemon_startup_retries} },
@@ -1290,12 +1291,6 @@ if (strncmpic(s, US"begin ", 6) == 0)
   return NULL;
   }
 
-#ifdef LOOKUP_MODULE_DIR
-/* Check for any required module load operations */
-
-//mod_load_check(s);
-#endif
-
 /* Return the first non-blank character. */
 
 return s;
@@ -4420,9 +4415,9 @@ store_pool = POOL_PERM;
   }
 store_pool = old_pool;
 
-/* Read the config file "authenticators" section, creating an auth instance list.
-For any yet-undiscovered driver, check for a loadable module and add it to
-those available. */
+/* Read the config file "authenticators" section, creating an auth instance
+list.  For any yet-undiscovered driver, check for a loadable module and add it
+to those available. */
 
 readconf_driver_init((driver_instance **)&auths,      /* chain anchor */
   (driver_info **)&auths_available,  /* available drivers */

